// Type definitions for quoted-printable v0.2.1
// Project: https://github.com/mathiasbynens/quoted-printable
// Definitions by: Jeffery Grajkowski <https://github.com/pushplay>
// Definitions: https://github.com/DefinitelyTyped/DefinitelyTyped

/**
 * A string representing the semantic version number.
 */
export const version: string;

/**
 * This function takes an encoded byte string (the input
 * parameter) and Quoted-Printable-encodes it. Each item
 * in the input string represents an octet as per the
 * desired character encoding.
 */
export function encode(input: string): string;

/**
 * This function takes a string of text (the text parameter)
 * and Quoted-Printable-decodes it. The return value is a
 * ‘byte string’, i.e. a string of which each item represents
 * an octet as per the character encoding that’s being used.
 */
export function decode(input: string): string;
